.TH SqlPipe Onyx
.SH NAME
SqlPipe.ppg \- Base-Grammar for SQL's over Pipes
.SH SYNOPSYIS
.nf
class SqlPipe : public SqlParser {
	int sql_in,sql_out,sql_err;
	long sql_timeout;
	
	SqlPipe();
	virtual ~SqlPipe();
	
	virtual int statement();
	virtual int select();
	virtual int other();
	
	virtual int sql_pipe(int *in,int *out,int *err);
	virtual int sql_close();
	
	virtual void sql_readpipe(int fd,int min,int timeout,Text *res);
	virtual void sql_read();
	
	virtual int sql_send(char *line);
	virtual int sql_sendmatch();
	virtual int sql_up();
	virtual void sql_purge();
	}
.fi
.SH DESCRIPTION
SqlPipe is a Base\-Grammar for SQL's over Pipes. Childs of this
class are SqlInformix and SqlShql, which only overloads sql_open().

Care has to be taken for the sql_timeout variable to make this
fast enough be dont lose results of the Engine.
.SH IMPLEMENTATION
.PP
statement : 
.br
.in +0.8i
.ad l
.nh
database  | select  | other  
.br
;
.br
.hy

Here database, select and other statements are checkt.
.PP
select : 
.br
.in +0.8i
.ad l
.nh
"select" matchexp  
.br
;
.br
.hy

This makes a unload statement form a select statement, so
it's posible to use the result. Informix has the stupid way
to somtimes use format the result like a table, and sometimes
like a sheet. Stupid comercial software.
.PP
other : 
.br
.in +0.8i
.ad l
.nh
true_  [ "insert" | "update" | "delete" ] matchexp  
.br
;
.br
.hy

All other statements are directly piped to the engine. If
It's insert, update or delete sql_timeout is set to 0 so
always wait for a result use them be calling sql_num().
Because I dont know if other statements have result, there
will be no wait for them.
.SH AUTHOR
Michael Koehne <kraehe@bakunin.north.de>
