.TH "Onyx Transactionprotokoll" 7
.SH NAME
SDTP \- Simple Database Transaction Protokoll
.SH DESCRIPTION
Databases are one of the main gold diggers in computing.

SQL is now the BASIC of the 90's.
But it's nerly imposible to connect a client in a simple
way to any database. Each DB vendor uses it own protokoll
for connecting clients and servers.

Tuxedo and other XA Transactionmanagers are not free
available as source. So it's difficult to connect a non
supported client platform to a SQL-Database.

SDTP is a simple protokoll based on inetd. Means TCP/STREAM
connect to a server started by inetd. GSQL is the project name
of my implentation and I like to see it in GNU-tree in the
near future. I'll use GSQL and SDTP synonymous here as GSQL
now is the only implementation available.

It's posible to access a database by shell, over a pipe, over
a socket or using C++.
.SH SHELL INTERFACE
To connect to a database using shell, Y can use gsql.
.sp
.in +0.4i
gsql [databasename] [statemens]*
.sp
.in -0.4i
Each statement has to be in a single argument. If statements
are ommited gsql takes his statments from stdin. So interactive
and batch access for all databases is in the same way.

If database is ommited Y need to use the "connect" statement
as Yr first statement. Y also can "disconnect" and "connect" to
an other database on a posible other host with an other engine.

Databases are named as :
.sp
.in +0.4i
database[%engine][@host[.domain]]
.sp
.in -0.4i

So 'vaws%ingres' means a local database using ingres as an
engine. 'vaws%informix@bakunin.north.de' means 
access to a database running under informix.

if '@host.domain' is ommited Yr localhost will be the server.
Y can chose a default engine on compile time.

Supported engines are now :
.sp
.in +0.4i
.nf
GAWK		If Y dont have a database engine.
Ingres89	University Ingres running on Linux
		SunOs or VAX/BSD
Yard		Kommercial X/OPEN SQL-2 compatible Engine running
		under linux.
Informix	Well known Engine.
.sp
.in -0.4i
.fi
Yr stop gsql by closing stdin or using the "by" statement.

Output row's from Yr jobs 'll be coming on stdout, errors and other
results are coming on stderr.

All rows are comming in a tab seperated file, normaly with ISO encoding.
If the remote database uses a different encoding (eg. DIN or PC-8)
this will be translated.
.SH C++ INTERFACE
Y can use gsql in C++. Normaly Y use an instance of the
TransactionManager-Class. Y can give a transaction calling
.sp
.in +0.4i
.nf
int sql_new(char *Init);
int sql_new(Text *Init);
int sql_new(LineStream *Init);
.sp
.in -0.4i
.fi
Y now can check the results and errors by calling sql_getresults().
Y can check the number of rows affected by calling sql_getnum().
Y can get the rows retrieved by a select statement by calling
sql_getstream() if Y want them all at a time, or calling sql_getrow()
if Y prefer to get them one after the other.

Y can call sql_up() anytime to check it Yr parser is connected to a
running database engine.

Transactions are written in what I call a BASIC SQL.
Y also can call it a cripled SQL, so if Y need a ANSI-SQL3 buy it,
dont flame be because my parsers are not ANSI compilant.

Any Statement have to end with a semicolon.
.SH SOCKET INTERFACE
The socket interface will be used if Y call gsql from shell, or
create an instance of SqlInet. The last one 'll be done when
Y give a "connect" statement to the SqlManager.

The socket interface is very simple. All statements will be send
to the socket. Any statement ends with a semicolon. After a statement
the server sends results and rows in the following protokoll :
.sp
.in +0.4i
.nf
# Seq BEGIN
# results and errors.
# Seq ROWS
> fields delimited by tabs ending with newline.
> and so on.
# Seq END
.sp
.in -0.4i
.fi
If there are no rows to retrieve the '# Seq ROW' line and the folloing
lines started with '>' are ommited.
.SH WARNING
The socket protokoll is on experimental state of disscussion.

Current implementation lacks on securetty (Y can call it YASH =
Yet another seccuretty hole) and scalability. Starting a 
TPC benchmark will kill Yr server !

I'm thinking of making a RFC on this protokoll and I'm sure the
hole protokoll will become redesigned.
.SH AUTHOR
Michael Koehne <kraehe@bakunin.north.de>
